
var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "led-wizard.log";
lWarn = new Logger(LOGFILE_NAME);
//lInfo = new Logger(LOGFILE_NAME);

function Debug(o){
	lInfo.logln(o);
}


function prepareCurve(oDevice,curve_id,fLZ) {
	var deviceProductID=oDevice.productID;
	var deviceFirmwareID=oDevice.revisionID;

	if (curve_id<0) {
		return doCalcCurve(Math.abs(curve_id),[], 0, deviceProductID, deviceFirmwareID,false, 0);
	} 
	var sResult = Property.getNode('dbcache').getValue();	
	sResult = sResult.replace(/&amp;/g, '&').replace(/&quot;/g, '"').replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/&#039;/g, '\'');
	var oCatalog=JSON.parse(sResult);
	var dimmbar_ab=-1;
	var curve=[];
	var AnAb=0;
	lInfo.logln('suche Kurve '+curve_id);
	for (var iIndex=0;iIndex<oCatalog.illuminant.length;iIndex++)
		for (var jIndex=0;jIndex<oCatalog.illuminant[iIndex].curves.length;jIndex++) {
			var oItem=oCatalog.illuminant[iIndex].curves[jIndex];
			lInfo.logln('suche Kurve '+curve_id + ' = ' + oItem.id);
			if (oItem.id==curve_id) {
				lInfo.logln('kurve gefunden');
				dimmbar_ab=oItem.dimmMin;
				AnAb=oItem.dimmType;
				for (var kIndex=0;kIndex<oItem.values.length;kIndex++) {
					curve.push({pos:oItem.values[kIndex].pos, value:oItem.values[kIndex].val});
				}
				curve.sort(function(a,b){return a.pos-b.pos;});
			}
		} 
	
	if (dimmbar_ab==-1) {
		return false;
	} else {		 
		if (AnAb>1)
			return doCalcCurve(1, curve, dimmbar_ab, deviceProductID, deviceFirmwareID,fLZ, AnAb&0x1);
		else
			return doCalcCurve(0, curve, dimmbar_ab, deviceProductID, deviceFirmwareID,fLZ, AnAb&0x1);		
	}
}

function executeProgramm(dsuid,id) {
    var iIndex;
    var oParameterList;
    if (dsuid.length > 1) {
        lInfo.logln('starteProgrammierung fr mehrere devices');
        for (iIndex = 0; iIndex < dsuid.length; iIndex++) {
            lInfo.logln('Device ' + dsuid[iIndex]);
        }
    }
	lInfo.logln('starteProgrammierung fr ' + dsuid[0] + ' mit ' +id);
	 try {    
	    Property.setProperty('temp/maxNrOfDevices', dsuid.length);
	    for (iIndex = 0; iIndex < dsuid.length; iIndex++) {
	        var oDevice=getDevices().byDSID(dsuid[iIndex]); //throws exception if device with dsuid not found    	        
    	    if (oDevice.getPropertyNode().getChild('present').getValue()==false) {
    	        var sErrorMSG='Gert ' + dsuid[iIndex] + ' aktuell nicht verfgbar';
    	        lWarn.logln(sErrorMSG);
                //set the needed temp property to delete the device in the complete step 
                Property.setProperty('temp/' + iIndex + '/catalogeID', id);
                Property.setProperty('temp/' + iIndex + '/dsuid', dsuid[iIndex]);
                Property.setProperty('temp/' + iIndex + '/action', 'delete');
                Property.setProperty('temp/' + iIndex + '/count', 0);
    	    } else {    	    
        	    //turn off the device before programming start
        	    new Event('led-wizard.demo',{actions:'setValue',dsuid:dsuid[iIndex],value:0}).raise();
        	    
        		lInfo.logln('prepareCurfe ' + dsuid[iIndex] + ' mit ' +id);
        		
        		oParameterList = prepareCurve(oDevice,id,false);
        		lInfo.logln('habe liste ' + oParameterList);		
        		
        		if (oParameterList != false) {
                    Property.setProperty('temp/' + iIndex + '/value', JSON.stringify(oParameterList));
                    Property.setProperty('temp/' + iIndex + '/step', 0);
                    Property.setProperty('temp/' + iIndex + '/catalogeID', id);
                    Property.setProperty('temp/' + iIndex + '/dsuid', dsuid[iIndex]);
                    Property.setProperty('temp/' + iIndex + '/action', 'programm');
                    Property.setProperty('temp/' + iIndex + '/count', oParameterList.length);
        		} else {
                    lWarn.logln('Fehler!: Keine Parameterliste vorhanden');
                    Property.setProperty('temp/' + iIndex + '/action', 'errorParamList');
                    Property.setProperty('temp/' + iIndex + '/count', 0);
        		}
    	    }
        }
	    //start with first device
	    Property.setProperty('temp/deviceIndex', 0);
	    var count= Property.getNode('temp/0/count').getValue();
        new Event('led-wizard.answer',{type:'step',detail:'prepare',count:count,currentDevice:0,maxNrOfDevices: dsuid.length}).raise();
        new Event('led-wizard.step',{detail:'prepare',count:count,currentDevice:0,maxNrOfDevices: dsuid.length}).raise();                           
	 } 
	 catch (e) {
		 lWarn.logln('Exception in led-wizard-prog.executeProgramm()'  + e);
		 new Event('led-wizard.step',{detail:'complete',error:true}).raise();
		 new Event('led-wizard.answer',{type:'step',detail:'complete',error:true}).raise();
	 }
}

/**
 * Removes the device with the given dsuid from the property tree without reseting the dimming curve.
 * This function is used if a device was deleted from the dSS. 
 * @param dsuid [in] dsuid of the device to be removed
 */
function deleteDevice(dsuid) {
    lInfo.logln('starte delete device fr ' + dsuid);
    //set the temp property for the complete step 
    Property.setProperty('temp/catalogeID', -1);
    Property.setProperty('temp/dsuid', dsuid);
    new Event('led-wizard.step',{detail:'complete',error:false}).raise();
    new Event('led-wizard.answer',{detail:'complete',type:'step',error:false}).raise();
}


if (raisedEvent.parameter.actions != null) {
    lInfo.logln("Event " +  raisedEvent.parameter.actions + " will be processed");
    Property.load();
	if (raisedEvent.parameter.actions == 'programmCurve') {
	    try {
            if (Property.getNode('/scripts/led-wizard/temp') != null) {
                lInfo.logln('try to delete temp node');
                Property.getNode('/scripts/led-wizard').removeChild('temp');
            }
            var oIDObject=JSON.parse(unescape(raisedEvent.parameter.dsuid));
            lInfo.logln("Eventparameter " + JSON.stringify(oIDObject));
            executeProgramm(oIDObject,raisedEvent.parameter.curve_id);   
	    } catch (e) {lInfo.logln('catch exception during delete temp node');}
    }
	if (raisedEvent.parameter.actions === 'deleteEntry') {
	    deleteDevice(raisedEvent.parameter.dsuid);
	}
}

	
